#include <iostream>
#include <vector>

using namespace std;

int main() {

    size_t number_count, bin_count;
    double min, max, bin_size;


    cerr << "Enter the number of elements: ";
    cin >> number_count;

    vector<double> numbers(number_count);

    cerr << "\nEnter " << number_count << " elements:" << endl;
    for (size_t i = 0; i < number_count; i++) {
        cin >> numbers[i];
    }


    cerr << "Enter the number of bins: ";
    cin >> bin_count;

    min = numbers[0];
    max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        } else {
            if (x > max) {
                max = x;
            }
        }
    }

    bin_size = (max - min) / bin_count;

    vector<size_t> bins(bin_count, 0);

    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((numbers[i] >= lo) && (numbers[i] <= hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    size_t max_count = bins[0];
    for (size_t i = 1; i < bin_count; i++) {
        if (bins[i] > max_count) {
            max_count = bins[i];
        }
    }

    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;


    short space_count;

    cerr << "\nHistogram:" << endl;

    if (max_count <= MAX_ASTERISK) {
        for (size_t i = 0; i < bin_count; i++) {
            if (bins[i] < 10) {
                space_count = 2;
            } else if (bins[i] >= 10 && bins[i] < 100) {
                space_count = 1;
            } else if (bins[i] >= 100 && bins[i] < 1000) {
                space_count = 0;
            }



            for (size_t k = 0; k < space_count; k++) {
                cout << " ";
            }

            cout << bins[i];

            cout << "|";


            for (size_t j = 0; j < bins[i]; j++) {
                cout << "*";
            }

            cout << "\n";
        }
    } else {
        for (size_t i = 0; i < bin_count; i++) {
            if (bins[i] < 10) {
                space_count = 2;
            } else if (bins[i] >= 10 && bins[i] < 100) {
                space_count = 1;
            } else if (bins[i] >= 100 && bins[i] < 1000) {
                space_count = 0;
            }


            for (size_t k = 0; k < space_count; k++) {
                cout << " ";
            }

            cout << bins[i];

            cout << "|";

            size_t height = static_cast<size_t>(MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count));
            for (size_t j = 0; j < height; j++) {
                cout << "*";
            }

            cout << "\n";
        }
    }

    return 0;
}
